#include <cmath>
#include "hsvcolor.hpp"

/* based on the code by Nan C. Schaller at
   http://www.cs.rit.edu/~ncs/color/t_convert.html */

RGBColor HSVtoRGB(float h, float s, float v) {
   RGBColor result;
   if (s == 0) {
      // achromatic (grey)
      return RGBColor(v, v, v);
   }
   h /= 60;
   int i = std::floor(h);
   float f = h - i;
   float p = v * (1 - s);
   float q = v * (1 - s * f);
   float t = v * (1 - s * (1 - f));

   switch (i) {
      case 0:  return RGBColor(v, t, p);
      case 1:  return RGBColor(q, v, p);
      case 2:  return RGBColor(p, v, t);
      case 3:  return RGBColor(p, q, v);
      case 4:  return RGBColor(t, p, v);
      default: return RGBColor(v, p, q);
   }
}
